#!/bin/perl

# This script creates a map of a directory on the http server.
# The map is used in conjuction with Sextant, a java applet that
# allows one to browse file hierarchies on the server
#
# Use: map.pl dir-to-map map-to-URL ext 
#
# Example: map.pl video http://trurl.npac.syr.edu/tango101/data 263
#
# Please, note: the script must be started in the parent directory
# of the directory being mapped. the URL must correspond to the PARENT
# directory. The script should be re-run each time you add or delete
# contents files. The script writes the output to siteMap.txt file.
#
# Author: Marek Podgorny, NPAC, Syracuse University

$narg = scalar(@ARGV);

if ( $narg < 3 ) {
  print "This script requires 3 arguments: \n";
  print " - name of the directory to map \n";
  print " - URL of the directory HOLDING the script\n";
  print " - file extension to look for \n";
  exit(-1);
}

$stem = @ARGV[0];
$baseurl = @ARGV[1];
$ext = @ARGV[2];

$ns = 1;

open (IN,"ls -R1F $stem|");
open (OUT,">siteMap.txt");

print OUT $baseurl,"/", $stem, " | ", $stem," | ", $stem,  "\n";

while($line=<IN>) {
  $ns0 = $ns;
  chop($line);  
  if ($line =~/\:/) {
    chop($line);
    $stem = $line;
    @chunks = split("/",$line);
    $ns = scalar(@chunks);
    $lastchunk = pop(@chunks);
    $lastchunk =~ tr/a-z/A-Z/;
    if ( $flag && $ns < $ns0 ) {
      for($i=1;$i<=$ns0;$i++) {print OUT " "}
      for($i=1;$i<=$ns0;$i++) {print OUT "-"}
      print OUT $baseurl, "/", $line0, "/ | no relevant files here | No files\n";
    }
    for($i=1;$i<$ns;$i++) {print OUT " "}
    for($i=1;$i<$ns;$i++) {print OUT "-"}
    print OUT $baseurl, "/", $line,"/", " | ", $lastchunk, " | ", $lastchunk,  "\n";
    $flag = 1;
    $line0 = $line;
  }
  elsif ($line =~ /$ext$/) {
    for($i=1;$i<=$ns;$i++) {print OUT  " "}
    for($i=1;$i<=$ns;$i++) {print OUT  "-"}
    print OUT $baseurl, "/", $stem, "/", $line," | ", $line, " | ", $line, "\n";
    $flag = 0;
  }
}
